//
//  AliyunPlayerRecordSourceView.h
//  AliyunVideoSDKPro
//
//  Created by coder.pi on 2021/9/18.
//  Copyright © 2021 aliyun. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <AVFoundation/AVFoundation.h>
#import "AlivcNativeAudioSourceController.h"

@class AliyunPlayerRecordSourceView;
@protocol AliyunPlayerRecordSourceViewDelegate <NSObject>
- (void) onAliyunPlayerRecordSourceView:(AliyunPlayerRecordSourceView *)sourceView
                   audioPrepareWithASBD:(const AudioStreamBasicDescription *)asbd;
- (void) onAliyunPlayerRecordSourceView:(AliyunPlayerRecordSourceView *)sourceView
                             bufferList:(const AudioBufferList *)bufferList
                            numberFrame:(CMItemCount)numberFrame;
@end

@interface AliyunPlayerRecordSourceView : UIView
@property (nonatomic, weak) id<AliyunPlayerRecordSourceViewDelegate> delegate;
@property (nonatomic, assign) CGFloat rate;
@property (nonatomic, readonly) UIView *targetView;
@property (nonatomic, readonly) AVPlayerLayer *playerLayer;
@property (nonatomic, readonly) AVAsset *asset;
@property (nonatomic, readonly) CGSize resolution;
@property (nonatomic, readonly) NSTimeInterval duration;
@property (nonatomic, readonly) AlivcNativeAudioSourceInfo *audioBasicDescription;
- (instancetype) initWithAsset:(AVAsset *)asset;
- (void) start;
- (void) stop;
- (void) seek:(NSTimeInterval)timeInSecond;
@end
